unit cmask;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Grids, StdCtrls;

type
	tRGBTripleArray = ARRAY[WORD] OF TRGBTriple;
	pRGBTripleArray = ^TRGBTripleArray;

	TXFrom = ( xf_Pattern1, xf_Pattern2, xf_Color );
	TXCommand = Record
		Color : Integer;
		XFrom : TXFrom;
		Value : Integer;
	End;

	TFormMask = class(TForm)
		Label1: TLabel;
		Label2: TLabel;
		Label3: TLabel;
		EditCharSet: TEdit;
    cmdPreProcess: TButton;
    grid: TStringGrid;
		EditMask1: TEdit;
		EditMask2: TEdit;
    cmdProcess: TButton;
		procedure FormCreate(Sender: TObject);
		procedure cmdPreProcessClick(Sender: TObject);
		procedure gridKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure cmdProcessClick(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
		imgCharset, imgMask1, imgMask2 : TPicture;
		imgNew : TPicture;
		nXCommands : Integer;
		XCommands : Array [ 0 .. 255 ] Of TXCommand;
		CommandMap : Array [ 0 .. 16000, 0 .. 1023 ] Of Byte;
		Function xRGB ( i : Integer ) : Integer;
		Function ToRGB ( i : Integer ) : Integer;
	end;

var
	FormMask: TFormMask;

implementation

{$R *.DFM}

procedure TFormMask.FormCreate(Sender: TObject);
begin
	EditCharSet.Text := 'C:\PROJECTS\PLUS4\Projects\Bmp2Chr\mask.bmp';
	EditMask1.Text := 'C:\PROJECTS\PLUS4\Projects\Bmp2Chr\border.bmp';
	EditMask2.Text := 'C:\PROJECTS\PLUS4\Projects\Bmp2Chr\inside.bmp';
end;

procedure TFormMask.cmdPreProcessClick(Sender: TObject);
var
	x, y : Integer;
	Color : Integer;
	i : Integer;
begin
	imgCharset := TPicture.Create;
	imgCharset.LoadFromFile ( EditCharSet.Text );
	//
	grid.RowCount := 2;
	//
	nXCommands := -1;
	For y := 0 To imgCharset.Bitmap.Height - 1 Do
	Begin
		For x := 0 To imgCharset.Bitmap.Width - 1 Do
		Begin
			Color := imgCharset.Bitmap.Canvas.Pixels [ x, y ];
			i := 0;
			While ( i <= nXCommands ) And ( XCommands [ i ].Color <> Color ) Do
			Begin
				Inc ( i );
			End;
			//
			If i > nXCommands Then
			Begin
				Inc ( nXCommands );
				i := nXCommands;
				//
				XCommands [ i ].Color := Color;
				XCommands [ i ].XFrom := xf_Color;
				XCommands [ i ].Value := 0;
			End;
			//
			CommandMap [ x, y ] := i;
		End;
		//
		Application.ProcessMessages;
		Caption := IntToStr ( y ) + '/' + IntToStr ( imgCharset.Bitmap.Height );
	End;
	//
	grid.RowCount := nXCommands + 2;
	For i := 0 To nXCommands Do
	Begin
		grid.Cells [ 0, i + 1 ] := IntToStr ( XCommands [ i ].Color );
		grid.Cells [ 1, i + 1 ] := 'Color';
		grid.Cells [ 2, i + 1 ] := '0';
	End;
	//
	Caption := 'Ready to process';
end;

procedure TFormMask.gridKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	If grid.Col = 1 Then
	Begin
		Case Key Of
			$31 :
			begin
				Key := 0;
				grid.Cells [ grid.Col, grid.Row ] := 'Mask1';
				XCommands [ grid.Row - 1 ].XFrom := xf_Pattern1;
			End;
			$32 :
			begin
				Key := 0;
				grid.Cells [ grid.Col, grid.Row ] := 'Mask2';
				XCommands [ grid.Row - 1 ].XFrom := xf_Pattern2;
			End;
			$43 :
			begin
				Key := 0;
				grid.Cells [ grid.Col, grid.Row ] := 'Color';
				XCommands [ grid.Row - 1 ].XFrom := xf_Color;
			End;
			Else
				Caption := IntToStr ( Key );
		End;
	End
	Else
	begin
		If grid.Col = 2 Then
		Begin
			Case Key Of
				$30:
				begin
					grid.Cells [ grid.Col, grid.Row ] := Chr ( Key );
					XCommands [ grid.Row - 1 ].Value := 0;
					Key := 0;
				End;
				$31,$32,$33 :
				begin
					grid.Cells [ grid.Col, grid.Row ] := '+' + Chr ( Key );
					XCommands [ grid.Row - 1 ].Value := Key - $30;
					Key := 0;
				End;
				$41,$42,$43 :
				begin
					grid.Cells [ grid.Col, grid.Row ] := '-' + Chr ( Key - $10 );
					XCommands [ grid.Row - 1 ].Value := -( Key - $40 );
					Key := 0;
				End;
				107 :
				Begin
					grid.Cells [ grid.Col, grid.Row ] := IntToStr ( StrToInt ( grid.Cells [ grid.Col, grid.Row ] ) + 1 );
					XCommands [ grid.Row - 1 ].Value := XCommands [ grid.Row - 1 ].Value + 1;
					Key := 0;
				End;
				109 :
				Begin
					grid.Cells [ grid.Col, grid.Row ] := IntToStr ( StrToInt ( grid.Cells [ grid.Col, grid.Row ] ) - 1 );
					XCommands [ grid.Row - 1 ].Value := XCommands [ grid.Row - 1 ].Value - 1;
					Key := 0;
				End;
				Else
					Caption := IntToStr ( Key );
			End;
		End;
	end;
end;

procedure TFormMask.cmdProcessClick(Sender: TObject);

var
	x, y : Integer;
	i : Integer;
	cmd : TXFrom;
	Value, col : Integer;
	sl : pRGBTripleArray;
begin
	imgMask1 := TPicture.Create;
	imgMask1.LoadFromFile ( EditMask1.Text );
	imgMask1.Bitmap.PixelFormat := pf24bit;
	//
	imgMask2 := TPicture.Create;
	imgMask2.LoadFromFile ( EditMask2.Text );
	imgMask2.Bitmap.PixelFormat := pf24bit;
	//
	imgNew := TPicture.Create;
	imgNew.Bitmap.Width := imgCharset.Bitmap.Width;
	imgNew.Bitmap.Height := imgCharset.Bitmap.Height;
	imgNew.Bitmap.PixelFormat := pf24bit;
	//
	For y := 0 To imgCharset.Bitmap.Height - 1 Do
	Begin
		//
		sl := imgNew.Bitmap.ScanLine [ y ];
		//
		For x := 0 To imgCharset.Bitmap.Width - 1 Do
		Begin
			i := CommandMap [ x, y ];
			cmd := XCommands [ i ].XFrom;
			Value := XCommands [ i ].Value;
			//
			Case cmd Of
				xf_Color : // color
				begin
					col := xRGB ( Value );
					sl^[x].rgbtRed := col;
					sl^[x].rgbtGreen := col;
					sl^[x].rgbtBlue := col;
				end;
				xf_Pattern1 : // pattern 1
				begin
					col := xRGB ( ToRGB ( imgMask1.Bitmap.Canvas.Pixels [ x Mod imgMask1.Bitmap.Width, y Mod imgMask1.Bitmap.Height ] ) + Value );
					sl^[x].rgbtRed := col;
					sl^[x].rgbtGreen := col;
					sl^[x].rgbtBlue := col;
				end;
				//
				xf_Pattern2 : // pattern 2
				begin
					col := xRGB ( ToRGB ( imgMask2.Bitmap.Canvas.Pixels [ x Mod imgMask2.Bitmap.Width, y Mod imgMask2.Bitmap.Height ] ) + Value );
					sl^[x].rgbtRed := col;
					sl^[x].rgbtGreen := col;
					sl^[x].rgbtBlue := col;
				end;
			End;
		End;
		//
		Application.ProcessMessages;
		Caption := IntToStr ( y ) + '/' + IntToStr ( imgCharset.Bitmap.Height );
	End;
	//
	imgNew.SaveToFile ( EditCharSet.Text + '.NEW.BMP' );
	//
	Caption := 'Finished!';
end;

Function TFormMask.xRGB ( i : Integer ) : Integer;
var
	x : Integer;
Begin
	If i < 0 Then i := 0;
	If i > 3 Then i := 3;
	x := i * 84;
	If x = 252 Then x := 255;
	xRGB := x;
end;

Function TFormMask.ToRGB ( i : Integer ) : Integer;
var
	x : Integer;
Begin
	i := i And 255;
	If i < 42 Then x := 0
	Else
		If i < 120 Then x := 1
		Else
			If i < 200 Then x := 2
			Else x := 3;
	ToRGB := x;
end;

end.
