unit proprts;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, Stringz, ExtCtrls, Globals;

type
	TFormProperties = class(TForm)
		lblWidth: TLabel;
		lblHeight: TLabel;
		lblPixels: TLabel;
		lblChars: TLabel;
		LabelColorMap: TLabel;
		LabelLayout: TLabel;
		LabelImageName: TLabel;
		EditWidth: TEdit;
		EditHeight: TEdit;
		EditWidthC: TEdit;
		EditHeightC: TEdit;
		EditName: TEdit;
		chkHires: TCheckBox;
		PanelColorMap: TPanel;
		PanelLayout: TPanel;
		cm0: TRadioButton;
		cm1: TRadioButton;
		cm2: TRadioButton;
		lay0: TRadioButton;
		lay1: TRadioButton;
		lay2: TRadioButton;
		cmdOk: TButton;
		cmdCancel: TButton;

		procedure cmdOkClick(Sender: TObject);
		procedure EditWidthCKeyUp(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure EditHeightCKeyUp(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure FormActivate(Sender: TObject);
		procedure EditWidthKeyUp(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure EditHeightChange(Sender: TObject);
		procedure cmdCancelClick(Sender: TObject);
		procedure EditWidthKeyPress(Sender: TObject; var Key: Char);
    procedure EditHeightKeyPress(Sender: TObject; var Key: Char);
    procedure EditWidthCKeyPress(Sender: TObject; var Key: Char);
    procedure EditHeightCKeyPress(Sender: TObject; var Key: Char);
	private
		{ Private declarations }
		procedure UpdateWidth;
		procedure UpdateHeight;
		procedure UpdateWidthC;
		procedure UpdateHeightC;
	public
		{ Public declarations }
	end;

var
	FormProperties: TFormProperties;

implementation

{$R *.DFM}

procedure TFormProperties.cmdOkClick(Sender: TObject);
Var
	w, h : Integer;
	s : String;
begin
	w := SafeVal ( EditWidth.Text );
	h := SafeVal ( EditHeight.Text );
	//
	s := '';
	If ( w < 0 ) Or ( w > MaxX ) Then
	Begin
		s := s + 'Invalid width, must be 0-' + IntToStr ( MaxX ) + '.' + #13;
	End;
	If ( h < 0 ) Or ( h > MaxY ) Then
	Begin
		s := s + 'Invalid height, must be 0-' + IntToStr ( MaxY ) + '.' + #13;
	End;
	//
	if s = '' Then
	Begin
		ModalResult := mrOk; // close
	End
	Else
	Begin
		ShowMessage ( s );
	End;
end;

procedure TFormProperties.EditWidthCKeyUp(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	UpdateWidth;
end;

procedure TFormProperties.UpdateWidth;
Var
	w : Integer;
Begin
	If IsNumbers ( EditWidthC.Text ) Then
	Begin
		w := SafeVal ( EditWidthC.Text );
		If ( w >= 0 ) And ( w <= ( MaxX Div 8 ) ) Then
		Begin
			EditWidth.Text := IntToStr ( w * 8 );
		End;
	End;
End;

procedure TFormProperties.UpdateHeight;
Var
	h : Integer;
Begin
	If IsNumbers ( EditHeightC.Text ) Then
	Begin
		h := SafeVal ( EditHeightC.Text );
		If ( h >= 0 ) And ( h <= ( MaxY Div 8 ) ) Then
		Begin
			EditHeight.Text := IntToStr ( h * 8 );
		End;
	End;
End;

procedure TFormProperties.UpdateWidthC;
Var
	w : Integer;
Begin
	If IsNumbers ( EditWidth.Text ) Then
	Begin
		w := SafeVal ( EditWidth.Text );
		If ( w >= 0 ) And ( w <= MaxX ) Then
		Begin
			EditWidthC.Text := IntToStr ( w Div 8 );
		End;
	End;
End;

procedure TFormProperties.UpdateHeightC;
Var
	h : Integer;
Begin
	If IsNumbers ( EditHeight.Text ) Then
	Begin
		h := SafeVal ( EditHeight.Text );
		If ( h >= 0 ) And ( h <= MaxY ) Then
		Begin
			EditHeightC.Text := IntToStr ( h Div 8 );
		End;
	End;
End;

procedure TFormProperties.EditHeightCKeyUp(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	UpdateHeight;
end;

procedure TFormProperties.FormActivate(Sender: TObject);
begin
	UpdateWidthC;
	UpdateHeightC;
end;

procedure TFormProperties.EditWidthKeyUp(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	UpdateWidthC;
end;

procedure TFormProperties.EditHeightChange(Sender: TObject);
begin
	UpdateHeightC;
end;

procedure TFormProperties.cmdCancelClick(Sender: TObject);
begin
	ModalResult := mrCancel; // close
end;

procedure TFormProperties.EditWidthKeyPress(Sender: TObject;
	var Key: Char);
Var
	Value : Integer;
begin
	Case Key Of

		#43 : { + plus }
		Begin
			Key := #0;
			Value := SafeVal ( EditWidth.Text );
			If Value < MaxX Then
			Begin
				EditWidth.Text := IntToStr ( Value + 1 );
				UpdateWidthC;
			End;
		End;

		#45 : { - minus }
		Begin
			Key := #0;
			Value := SafeVal ( EditWidth.Text );
			If Value > 0 Then
			Begin
				EditWidth.Text := IntToStr ( Value - 1 );
				UpdateWidthC;
			End;
		End;

		Else
			Caption := IntToStr ( Ord ( Key ) );
	End;
end;

procedure TFormProperties.EditHeightKeyPress(Sender: TObject;
	var Key: Char);
Var
	Value : Integer;
begin
	Case Key Of

		#43 : { + plus }
		Begin
			Key := #0;
			Value := SafeVal ( EditHeight.Text );
			If Value < MaxY Then
			Begin
				EditHeight.Text := IntToStr ( Value + 1 );
				UpdateHeightC;
			End;
		End;

		#45 : { - minus }
		Begin
			Key := #0;
			Value := SafeVal ( EditHeight.Text );
			If Value > 0 Then
			Begin
				EditHeight.Text := IntToStr ( Value - 1 );
				UpdateHeightC;
			End;
		End;

		Else
			Caption := IntToStr ( Ord ( Key ) );
	End;
end;

procedure TFormProperties.EditWidthCKeyPress(Sender: TObject;
  var Key: Char);
Var
	Value : Integer;
begin
	Case Key Of

		#43 : { + plus }
		Begin
			Key := #0;
			Value := SafeVal ( EditWidthC.Text );
			If Value < ( MaxX Div 8 ) Then
			Begin
				EditWidthC.Text := IntToStr ( Value + 1 );
				UpdateWidth;
			End;
		End;

		#45 : { - minus }
		Begin
			Key := #0;
			Value := SafeVal ( EditWidthC.Text );
			If Value > 0 Then
			Begin
				EditWidthC.Text := IntToStr ( Value - 1 );
				UpdateWidth;
			End;
		End;

		Else
			Caption := IntToStr ( Ord ( Key ) );
	End;
end;

procedure TFormProperties.EditHeightCKeyPress(Sender: TObject;
	var Key: Char);
Var
	Value : Integer;
begin
	Case Key Of

		#43 : { + plus }
		Begin
			Key := #0;
			Value := SafeVal ( EditHeightC.Text );
			If Value < ( MaxY Div 8 ) Then
			Begin
				EditHeightC.Text := IntToStr ( Value + 1 );
				UpdateHeight;
			End;
		End;

		#45 : { - minus }
		Begin
			Key := #0;
			Value := SafeVal ( EditHeightC.Text );
			If Value > 0 Then
			Begin
				EditHeightC.Text := IntToStr ( Value - 1 );
				UpdateHeight;
			End;
		End;

		Else
			Caption := IntToStr ( Ord ( Key ) );
	End;
end;

end.
